#!/usr/bin/env python
# -*- coding: utf-8 -*-
# postserver.py
# Spécial sample v2 powerded by Bud 'Robert' Spencer
# launch cmd : python postserver2.py

from time import sleep
import threading;import subprocess;import signal;import sys
import RPi.GPIO as GPIO

GPIO.setmode(GPIO.BCM);GPIO.setwarnings(False)

led = 18
bt0 = [0,0];bt1 = [1,0];bt2 = [4,0];bt3 = [17,0];bt4 = [21,0];
bt5 = [22,0];bt6 = [10,0];bt7 = [9,0];bt8 = [11,0];bt9 = [7,0];
bt10 = [8,0];bt11 = [25,0];bt12 = [24,0];bt13 = [23,0];bt14 = [15,0];
bts = [bt0,bt1,bt2,bt3,bt5,bt6,bt7,bt8,bt9,bt10,bt11,bt12,bt13,bt14]

def send(gpio,mode):
	subprocess.Popen(['python','postclient.py',
	str(gpio),str(mode)], stdout=0)
	
def getGPIO(timing):
	if len(bts) == 0:
		print ('\nBud Spencer mailbox as free')
		sleep(2);GPIO.cleanup();sys.exit(0)	
	
	threading.Timer(timing,getGPIO,[timing]).start()
	i = 0			
	for bt in bts:
		if GPIO.input(bt[0])==0:bt[1]+= 1; i = 1
		else:
			if bt[1] > 0:send(bt[0],bt[1])
			bt[1] = 0 
		GPIO.output(led,i)

def signal_hndl(signal,f):bts.clear();	
			
def main():
	print ('Bud Spencer as PostMaster V2')
	for bt in bts: GPIO.setup(bt[0],GPIO.IN,pull_up_down=GPIO.PUD_UP)
	GPIO.setup(led,GPIO.OUT)
	signal.signal(signal.SIGINT,signal_hndl)		
	getGPIO(0.1)
	return 0

if __name__ == '__main__':
	main()

